## seqan3 3.0.0.0.git.20200110.b42671eac39

=== test/coverage/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2019, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2019, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.7)
project (seqan3_test_coverage CXX)

include (../seqan3-test.cmake)

if (CMAKE_BUILD_TYPE AND NOT ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug"))
    message(WARNING "Coverage test must be build in debug mode [build type = ${CMAKE_BUILD_TYPE}]")
endif ()

find_program (LCOV_COMMAND  NAMES lcov lcov.bat lcov.exe lcov.perl)
find_program (GENHTML_COMMAND NAMES genhtml genhtml.perl genhtml.bat)

if (NOT LCOV_COMMAND)
    message(FATAL_ERROR "lcov not found! Aborting...")
endif ()

# Files which should not be included in the coverage report
set (TEST_COVERAGE_EXCLUDE_FILES
    "'/usr/*'"
    "'${SEQAN3_CLONE_DIR}/include/seqan3/contrib/*'"
    "'${SEQAN3_CLONE_DIR}/include/seqan3/std/*'"
    "'${SEQAN3_CLONE_DIR}/submodules/*'"
    "'${SEQAN3_CLONE_DIR}/test/unit/*'"
    "'${PROJECT_BINARY_DIR}/vendor/*'"
)
# Holds all target's defined by seqan3_test
set_property (GLOBAL PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS "")

add_custom_command (
    OUTPUT ${PROJECT_BINARY_DIR}/seqan3_coverage
    # Cleanup lcov (resetting code coverage counters to zero)
    COMMAND ${LCOV_COMMAND} --directory ${PROJECT_BINARY_DIR} --zerocounters
    # Create baseline to make sure untouched files show up in the report
    COMMAND ${LCOV_COMMAND} --directory ${PROJECT_BINARY_DIR} --capture --initial --output-file ${PROJECT_BINARY_DIR}/seqan3_coverage.baseline

    # Run tests
    COMMAND ${CMAKE_CTEST_COMMAND}

    # Capturing lcov counters and generating report
    COMMAND ${LCOV_COMMAND} --directory ${PROJECT_BINARY_DIR} --capture --output-file ${PROJECT_BINARY_DIR}/seqan3_coverage.captured
    # merge baseline counters and captured counters
    COMMAND ${LCOV_COMMAND} -a ${PROJECT_BINARY_DIR}/seqan3_coverage.baseline -a ${PROJECT_BINARY_DIR}/seqan3_coverage.captured --output-file ${PROJECT_BINARY_DIR}/seqan3_coverage.total
    COMMAND ${LCOV_COMMAND} --remove ${PROJECT_BINARY_DIR}/seqan3_coverage.total ${TEST_COVERAGE_EXCLUDE_FILES} --output-file ${PROJECT_BINARY_DIR}/seqan3_coverage

    BYPRODUCTS seqan3_coverage.baseline seqan3_coverage.captured seqan3_coverage.total

    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    COMMENT "Processing code coverage counters."
)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "seqan3_coverage.baseline;seqan3_coverage.captured;seqan3_coverage.total")

add_custom_target (
    coverage ALL
    DEPENDS
    ${PROJECT_BINARY_DIR}/seqan3_coverage
)

add_custom_target (
    coverage_html
    COMMAND ${GENHTML_COMMAND} --highlight --legend --output-directory html ${PROJECT_BINARY_DIR}/seqan3_coverage
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
    DEPENDS coverage
    COMMENT "Generate coverage report."
)

add_custom_command(
    TARGET coverage_html POST_BUILD
    COMMAND ;
    COMMENT "Open ${PROJECT_BINARY_DIR}/html/index.html in your browser to view the coverage report."
)

macro (seqan3_test unit_test_cpp)
    file (RELATIVE_PATH unit_test "${CMAKE_SOURCE_DIR}/../unit" "${CMAKE_CURRENT_LIST_DIR}/${unit_test_cpp}")
    seqan3_test_component (target "${unit_test}" TARGET_NAME)
    seqan3_test_component (test_name "${unit_test}" TEST_NAME)

    add_executable (${target} ${unit_test_cpp})
    target_link_libraries (${target} seqan3::test::coverage)
    add_test (NAME "${test_name}" COMMAND ${target})

    # any change of a target will invalidate the coverage result;
    # NOTE that this is a GLOBAL variable, because a normal
    # `set(GLOBAL_TEST_COVERAGE_ALL_TESTS)` would not propagate the result when
    # CMakeLists.txt goes out of scope due to a `add_subdirectory`
    set_property(GLOBAL APPEND PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS ${target})

    unset (unit_test)
    unset (target)
    unset (test_name)
endmacro ()

seqan3_require_ccache ()
seqan3_require_test ()

# add all unit tests
add_subdirectories_of ("${CMAKE_CURRENT_SOURCE_DIR}/../unit")

# add collected test cases as dependency
get_property(TEST_COVERAGE_ALL_TESTS GLOBAL PROPERTY GLOBAL_TEST_COVERAGE_ALL_TESTS)
add_custom_command (
    OUTPUT ${PROJECT_BINARY_DIR}/seqan3_coverage
    DEPENDS ${TEST_COVERAGE_ALL_TESTS}
    APPEND
)

=== test/documentation/CMakeLists.txt ===
# Minimum cmake version
cmake_minimum_required(VERSION 3.7)

# Name of project
project(seqan3_documentation NONE)

### Find seqan3
if (NOT SEQAN3_INCLUDE_DIR)
    find_path (SEQAN3_INCLUDE_DIR NAMES seqan3/version.hpp HINTS "${CMAKE_SOURCE_DIR}/../../include")
endif ()

if (NOT EXISTS "${SEQAN3_INCLUDE_DIR}/seqan3/version.hpp")
    message (FATAL_ERROR "Could not find SeqAn3. Not building documentation.")
endif ()
message (STATUS "Found: ${SEQAN3_INCLUDE_DIR}")

set (SEQAN3_DOXYGEN_INPUT_DIR "${CMAKE_SOURCE_DIR}")

include (seqan3-doxygen.cmake)

### Enable testing
enable_testing()

set (SEQAN3_DOXYGEN_TEST_SCRIPT "
    output=\$(${DOXYGEN_EXECUTABLE} 2>&1 > /dev/null | sort);
    echo \"\$output\";
    test -z \"\$output\"")

if (SEQAN3_USER_DOC)
    message (STATUS "Add user doc test.")
    add_test(NAME doc_usr_test
    COMMAND sh -c "${SEQAN3_DOXYGEN_TEST_SCRIPT}"
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doc_usr)
endif ()

if (SEQAN3_DEV_DOC)
    message (STATUS "Add dev doc test.")
    add_test(NAME doc_dev_test
    COMMAND sh -c "${SEQAN3_DOXYGEN_TEST_SCRIPT}"
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}/doc_dev)
endif ()

=== test/header/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2019, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2019, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.7)
project (seqan3_header_test CXX)

include (../seqan3-test.cmake)

option (SEQAN3_FULL_HEADER_TEST "Test seqan3 headers as well as the headers of external libraries" OFF)

# We compile each header twice in separate compilation units. Each alone is
# sufficient to test that the header is functional, but both are needed to check
# for link errors, which can happen if the header accidentally defines a
# variable, e.g. a global or class static member. Furthermore this tests that
# header guards are working by including the same header twice.
#
# example invocation:
#     seqan3_header_test (seqan3 "<path>/include/seqan3" "test.hpp|/folder/|test2.hpp")
#
# \param component        The component name, will create the target `${component}_header_test`
# \param header_base_path The base path to the header files
# \param exclude_regex    A regular expression on the header file paths that excludes them from the header test. For
#                         regex syntax see https://cmake.org/cmake/help/v3.15/command/string.html#regular-expressions.
#
# \sa Modified version from Bio-Formats
# https://github.com/openmicroscopy/bioformats/blob/d3bb33eeda23e81f78fd25f658bfc14a4363805f/cpp/cmake/HeaderTest.cmake#L81-L113
macro (seqan3_header_test component header_base_path exclude_regex)
    set (target "${component}_header_test")

    # finding all *.hpp files relative from the current directory (e.g. /test/)
    # The resulting list is normalized to `header_base_path` that means concatenating
    # "${header_base_path}/header_files[i]" will result in an absolute path to the file
    #
    # Example output:
    #   seqan3/alphabet/adaptation/all.hpp
    #   seqan3/alphabet/adaptation/char.hpp
    #   seqan3/alphabet/adaptation/concept.hpp
    #   seqan3/alphabet/adaptation/uint.hpp
    #   seqan3/alphabet/all.hpp
    #   seqan3/alphabet/dna5_detail.hpp <- will be filtered out
    #   ....
    seqan3_test_files (header_files "${header_base_path}" "*.hpp;*.h")

    # filter out headers
    if (NOT ";${exclude_regex};" STREQUAL ";;")
        list (FILTER header_files EXCLUDE REGEX "${exclude_regex}")
    endif()

    file (WRITE "${PROJECT_BINARY_DIR}/${target}.cpp" "")
    add_executable (${target} ${PROJECT_BINARY_DIR}/${target}.cpp)
    target_link_libraries (${target} seqan3::test::header)
    add_test (NAME "header/${target}" COMMAND ${target})

    foreach (header ${header_files})
        foreach (repeat 1 2)
            seqan3_test_component (header_test_name "${header}" TEST_NAME)
            seqan3_test_component (header_target_name "${header}" TARGET_UNIQUE_NAME)
            set (header_target_source "${PROJECT_BINARY_DIR}/${target}_files/${header_test_name}-${repeat}.cpp")
            set (header_target_name "${header_target_name}-${repeat}")
            set (header_target "${target}--${header_target_name}")

            string (REPLACE "-" "__" header_test_name_safe "${target}, ${header_target}")
            file (WRITE "${header_target_source}" "
#include <${header}>
#include <${header}>
#include <gtest/gtest.h>
#include <benchmark/benchmark.h>
TEST(${header_test_name_safe}) {}")

            # test that seqan3 headers include platform.hpp
            if ("${component}" MATCHES "seqan3")
                file (APPEND "${header_target_source}" "
#ifndef SEQAN3_DOXYGEN_ONLY
#error \"Your header file is missing #include <seqan3/core/platform.hpp>\"
#endif")

                # test whether seqan3 has the visibility bug on lower gcc versions
                # https://github.com/seqan/seqan3/issues/1317
                file (APPEND "${header_target_source}" "
class A{ int i{5}; };

template <typename t>
SEQAN3_CONCEPT private_bug = requires(t a){a.i;};

static_assert(!private_bug<A>, \"See https://github.com/seqan/seqan3/issues/1317\");")
            endif ()

            add_library (${header_target} OBJECT "${header_target_source}")
            # NOTE: a simple target_link_libraries (${header_target} seqan3::test::header)
            # is not possible for OBJECT libraries before cmake 3.12
            if (CMAKE_VERSION VERSION_LESS 3.12)
                target_compile_options (${header_target} PRIVATE $<TARGET_PROPERTY:seqan3::test::header,INTERFACE_COMPILE_OPTIONS>)
                target_compile_definitions (${header_target} PRIVATE $<TARGET_PROPERTY:seqan3::test::header,INTERFACE_COMPILE_DEFINITIONS>)
                target_include_directories (${header_target} PRIVATE $<TARGET_PROPERTY:seqan3::test::header,INTERFACE_INCLUDE_DIRECTORIES>)
                add_dependencies (${header_target} gtest gbenchmark)
            else ()
                target_link_libraries (${header_target} seqan3::test::header)
            endif ()

            target_sources (${target} PRIVATE $<TARGET_OBJECTS:${header_target}>)
        endforeach ()
    endforeach ()

    unset (target)
    unset (header_files)
    unset (header_test_name)
    unset (header_test_name_safe)
    unset (header_target_name)
    unset (header_target_source)
    unset (header_target)
endmacro ()

seqan3_require_ccache ()
seqan3_require_benchmark ()
seqan3_require_test ()

seqan3_header_test (seqan3 "${SEQAN3_CLONE_DIR}/include" "")
seqan3_header_test (seqan3_test "${SEQAN3_CLONE_DIR}/test/include" "")

if (SEQAN3_FULL_HEADER_TEST)

    # contains deprecated headers that produce an error when included
    seqan3_header_test (range-v3 "${SEQAN3_CLONE_DIR}/submodules/range-v3/include" "/detail/")
    target_compile_definitions (range-v3_header_test INTERFACE RANGES_DISABLE_DEPRECATED_WARNINGS=1)

    # not self-contained headers; error: extra ‘;’ [-Werror=pedantic]
    # seqan3_header_test (lemon "${SEQAN3_CLONE_DIR}/submodules/lemon/include" "")

    # not complete self-contained headers
    seqan3_header_test (cereal "${SEQAN3_CLONE_DIR}/submodules/cereal/include" "/external/|polymorphic_impl\.hpp")

    seqan3_header_test (sdsl-lite "${SEQAN3_CLONE_DIR}/submodules/sdsl-lite/include" "")

endif ()

=== test/performance/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2019, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2019, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.7)
project (seqan3_test_performance CXX)

include (../seqan3-test.cmake)

macro (seqan3_benchmark benchmark_cpp)
    file (RELATIVE_PATH benchmark "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_LIST_DIR}/${benchmark_cpp}")
    seqan3_test_component (target "${benchmark}" TARGET_NAME)
    seqan3_test_component (test_name "${benchmark}" TEST_NAME)

    # Force alignment of benchmarked loops so that numbers are reliable.
    # For large loops and erratic seeming bench results the value might
    # have to be adapted or the option deactivated.
    option (BENCHMARK_ALIGN_LOOPS "Pass -falign-loops=32 to the benchmark builds." ON)

    add_executable (${target} ${benchmark_cpp})
    target_link_libraries (${target} seqan3::test::performance)
    if (BENCHMARK_ALIGN_LOOPS)
        target_compile_options (${target} PUBLIC "-falign-loops=32")
    endif ()
    add_test (NAME "${test_name}" COMMAND ${target})

    unset (benchmark)
    unset (target)
    unset (test_name)
endmacro ()

seqan3_require_ccache ()
seqan3_require_benchmark ()

add_subdirectories ()

=== test/snippet/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2019, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2019, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.7)
project (seqan3_test_snippet CXX)

include (../seqan3-test.cmake)

macro (seqan3_snippet test_name_prefix snippet snippet_base_path)
    seqan3_test_component (snippet_target_name "${snippet}" TARGET_NAME)
    seqan3_test_component (snippet_test_name "${snippet}" TEST_NAME)
    seqan3_test_component (snippet_target_path "${snippet}" TARGET_PATH)
    set (target "${snippet_target_name}_snippet")

    add_executable (${target} "${snippet_base_path}/${snippet}")
    target_link_libraries (${target} seqan3::test::unit)
    target_compile_options (${target} PUBLIC "-Wno-unused")
    set_target_properties(${target}
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${snippet_target_path}"
    )

    add_test (NAME "${test_name_prefix}/${snippet_test_name}_snippet" COMMAND ${target})

    unset (snippet_target_name)
    unset (snippet_test_name)
    unset (snippet_target_path)
    unset (target)
endmacro ()

macro (seqan3_snippets test_name_prefix snippet_base_path)
    seqan3_test_files (snippet_files "${snippet_base_path}" "*.cpp")
    foreach (snippet ${snippet_files})
        seqan3_snippet("${test_name_prefix}" "${snippet}" "${snippet_base_path}")
    endforeach ()
endmacro ()

seqan3_require_ccache ()
seqan3_require_test ()

seqan3_snippets ("doc/snippet" "${CMAKE_SOURCE_DIR}/../../doc")
seqan3_snippets ("snippet" "${CMAKE_SOURCE_DIR}")

=== test/unit/CMakeLists.txt ===
# -----------------------------------------------------------------------------------------------------
# Copyright (c) 2006-2019, Knut Reinert & Freie Universität Berlin
# Copyright (c) 2016-2019, Knut Reinert & MPI für molekulare Genetik
# This file may be used, modified and/or redistributed under the terms of the 3-clause BSD-License
# shipped with this file and also available at: https://github.com/seqan/seqan3/blob/master/LICENSE.md
# -----------------------------------------------------------------------------------------------------

cmake_minimum_required (VERSION 3.7)
project (seqan3_test_unit CXX)

include (../seqan3-test.cmake)

macro (seqan3_test unit_test_cpp)
    file (RELATIVE_PATH unit_test "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_LIST_DIR}/${unit_test_cpp}")
    seqan3_test_component (target "${unit_test}" TARGET_NAME)
    seqan3_test_component (test_name "${unit_test}" TEST_NAME)

    add_executable (${target} ${unit_test_cpp})
    target_link_libraries (${target} seqan3::test::unit)
    add_test (NAME "${test_name}" COMMAND ${target})

    unset (unit_test)
    unset (target)
    unset (test_name)
endmacro ()

seqan3_require_ccache ()
seqan3_require_test ()

add_subdirectories ()

=== test/performance/io/CMakeLists.txt ===
seqan3_benchmark(stream_input_benchmark.cpp)
seqan3_benchmark(stream_output_benchmark.cpp)
seqan3_benchmark(format_fasta_benchmark.cpp)
seqan3_benchmark(format_vienna_benchmark.cpp)

=== debian/changelog ===
seqan3 (3.0.0.0.git.20200110.b42671eac39-1) unstable; urgency=medium

  * Experimental snapshot from upstream
  * Try using the Debian package for range-v3

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Jan 2020 15:41:25 +0100

=== debian/control ===
Source: seqan3
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               ninja-build,
               zlib1g-dev <!nocheck>,
               libbz2-dev <!nocheck>,
               libboost-dev <!nocheck>,
               libgtest-dev <!nocheck>,
               libcereal-dev <!nocheck>,
               libbenchmark-dev <!nocheck>,
               ccache <!nocheck>,
               librange-v3-dev <!nocheck>
Build-Depends-Indep: doxygen <!nodoc>,
                     graphviz <!nodoc>,
                     cppreference-doc-en-html <!nodoc>,
                     texlive-latex-base <!nodoc>,
                     ghostscript <!nodoc>
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/med-team/seqan3
Vcs-Git: https://salsa.debian.org/med-team/seqan3.git
Homepage: http://www.seqan.de/
Rules-Requires-Root: no

Package: libseqan3-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, zlib1g-dev, libbz2-dev, libcereal-dev
Description: C++ library for the analysis of biological sequences v3 (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

Package: seqan3-doc
Architecture: all
Section: doc
Suggests: libseqan3-dev
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: C++ library for the analysis of biological sequences v3 (documentation)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the documentation and examples

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DH_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
export HOME=$(CURDIR)/fakehome
export SEQAN3_NO_VERSION_CHECK=1

# include /usr/share/dpkg/architecture.mk
# ifneq (,$(filter armel armhf arm64,$(DEB_BUILD_ARCH)))
# 	DEB_CXXFLAGS_MAINT_APPEND+=-Wno-maybe-uninitialized
# 	DEB_CFLAGS_MAINT_APPEND+=-Wno-maybe-uninitialized
# endif
# see https://github.com/seqan/seqan3/issues/1381 for a discussion with upstream

export DEB_CFLAGS_MAINT_APPEND+=-O3
export DEB_CXXFLAGS_MAINT_APPEND+=-DNDEBUG -O3 -std=c++2a

pkgdev=libseqan3-dev

%:
	dh $@

override_dh_auto_configure-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
	dh_auto_configure --builddirectory=build_unit --sourcedirectory=test/unit --buildsystem=cmake+ninja
	dh_auto_configure --builddirectory=build_header --sourcedirectory=test/header --buildsystem=cmake+ninja
	dh_auto_configure --builddirectory=build_snippet --sourcedirectory=test/snippet --buildsystem=cmake+ninja
	dh_auto_configure --builddirectory=build_performance --sourcedirectory=test/performance --buildsystem=cmake+ninja
endif

override_dh_auto_configure-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_configure --builddirectory=build_documentation --sourcedirectory=test/documentation --buildsystem=cmake+ninja
endif

override_dh_auto_build-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
	dh_auto_build --builddirectory=build_unit --sourcedirectory=test/unit --buildsystem=cmake+ninja
	dh_auto_build --builddirectory=build_header --sourcedirectory=test/header --buildsystem=cmake+ninja
	dh_auto_build --builddirectory=build_snippet --sourcedirectory=test/snippet --buildsystem=cmake+ninja
	dh_auto_build --builddirectory=build_performance --sourcedirectory=test/performance --buildsystem=cmake+ninja
endif

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_build --builddirectory=build_documentation --sourcedirectory=test/documentation --buildsystem=cmake+ninja
endif

override_dh_auto_clean-arch:
	dh_auto_clean --builddirectory=build_unit --sourcedirectory=test/unit --buildsystem=cmake+ninja || /bin/true
	dh_auto_clean --builddirectory=build_header --sourcedirectory=test/header --buildsystem=cmake+ninja || /bin/true
	dh_auto_clean --builddirectory=build_snippet --sourcedirectory=test/snippet --buildsystem=cmake+ninja || /bin/true
	dh_auto_clean --builddirectory=build_performance --sourcedirectory=test/performance --buildsystem=cmake+ninja || /bin/true

override_dh_auto_clean-indep:
	dh_auto_clean --builddirectory=build_documentation --sourcedirectory=test/documentation --buildsystem=cmake+ninja || /bin/true

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
	cd build_unit && /usr/bin/cmake -E cmake_echo_color --switch= --cyan "Running tests..." \
		&& /usr/bin/ctest --force-new-ctest-process --output-on-failure -E version_check_
	dh_auto_test --builddirectory=build_header --sourcedirectory=test/header --buildsystem=cmake+ninja
	dh_auto_test --builddirectory=build_snippet --sourcedirectory=test/snippet --buildsystem=cmake+ninja
	dh_auto_test --builddirectory=build_performance --sourcedirectory=test/performance --buildsystem=cmake+ninja
endif

ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
	#dh_auto_test --builddirectory=build_documentation --sourcedirectory=test/documentation --buildsystem=cmake+ninja
	# fails due to same error ignored in the build
endif
endif

override_dh_auto_install-arch:
	echo Nothing to install with dh_auto_install

override_dh_auto_install-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	rm -Rf $(CURDIR)/debian/$(pkgdev)/usr/share/doc/seqan
endif

override_dh_installdocs-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_installdocs  --doc-main-package libseqan3-dev
	dh_doxygen
endif

override_dh_install-indep:
	dh_install --indep

override_dh_install-arch:
	dh_install --arch
	if [ -d $(CURDIR)/debian/$(pkgdev) ] ; then \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name LICENSE -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name license.txt -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name .gitignore -delete ; \
	fi

## seqan3 3.0.1%2Bds

=== submodules/sdsl-lite/external/CMakeLists.txt ===
find_package(Git)
if(NOT GIT_FOUND)   
    message(WARNING "git not found. Cloning of submodules will not work.")
endif()

## Add gtest 
set(gtest_dir ${CMAKE_CURRENT_LIST_DIR}/googletest)
set(gtest_file ${gtest_dir}/CMakeLists.txt)
if(NOT EXISTS ${gtest_file})
    EXECUTE_PROCESS(COMMAND git submodule update --init external/googletest
                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/..
                    OUTPUT_QUIET
            )
endif(NOT EXISTS ${gtest_file})

add_subdirectory(googletest EXCLUDE_FROM_ALL)

## Add cereal
if(SDSL_CEREAL)
	MESSAGE(STATUS "Adding cereal")
	set(cereal_dir ${CMAKE_CURRENT_LIST_DIR}/cereal/include/cereal)
	set(cereal_file ${cereal_dir}/cereal.hpp)
	if(NOT EXISTS ${cereal_file})
	    EXECUTE_PROCESS(COMMAND git submodule update --init external/cereal
	                    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/..
	                    OUTPUT_QUIET
	            )
	endif(NOT EXISTS ${cereal_file})

	file(GLOB_RECURSE hppFiles RELATIVE ${cereal_dir} "${cereal_dir}/*.(h|hpp)") # select all .hpp-files

	foreach(hppFile ${hppFiles}) # copy each file
		configure_file( "${cereal_dir}/${hppFile}" "${CMAKE_CURRENT_BINARY_DIR}/cereal/include/cereal/${hppFile}" COPYONLY )
		install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cereal/include/cereal/${hppFile}" DESTINATION external/cereal/include/cereal)
	endforeach(hppFile)
	MESSAGE(STATUS "Adding cereal - done")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSDSL_HAS_CEREAL=1")
endif(SDSL_CEREAL)

=== submodules/sdsl-lite/extras/CMakeLists.txt ===
include(Colors)

# (1) generate docs
if(GENERATE_DOC)
  find_package(Doxygen)
    if(DOXYGEN_FOUND)
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/extras/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
        add_custom_target(docs ALL
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
        )
    endif(DOXYGEN_FOUND)
endif(GENERATE_DOC)

## (2) Add 'uninstall' target ##
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/../CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/../CMakeModules/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall-sdsl
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake")

# (3) packaging information
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/../sdsl-lite.pc.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/sdsl-lite.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sdsl-lite.pc"
        DESTINATION "lib/pkgconfig")

find_program(CLANG_FORMAT NAMES clang-format-4.0 clang-format-3.9 clang-format-3.8 clang-format-3.7 clang-format-3.6 clang-format-3.5 clang-format-3.4 clang-format)
if(CLANG_FORMAT)
  message(STATUS "${Green}clang-format found: ${CLANG_FORMAT}${ColourReset}")
else()
  message(STATUS "${Yellow}clang-format NOT found!${ColourReset}")
endif(CLANG_FORMAT)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pre-commit.cmake"
		       "${CMAKE_CURRENT_SOURCE_DIR}/pre-commit" @ONLY)

=== test/performance/core/CMakeLists.txt ===
add_subdirectories ()
seqan3_benchmark(bit_manipulation_benchmark.cpp)

=== submodules/sdsl-lite/benchmark/k2_trees/Makefile ===
include ../../Make.helper
CFLAGS = $(MY_CXX_FLAGS)
SRC_DIR = src
BIN_DIR = bin
LIBS =

C_OPTIONS:=$(call config_ids,compile_options.config)
TC_IDS:=$(call config_ids,test_case.config)
K2_IDS:=$(call config_ids,k2tree.config)

DL = $(foreach TC_ID,$(TC_IDS),\
		$(call config_select,test_case.config,$(TC_ID),2))
DL_K2T = $(foreach TC_ID,$(TC_IDS),\
		 	$(foreach K2_ID,$(K2_IDS),\
		 		../tmp/K2T.$(TC_ID).$(K2_ID)))

K2_EXECS = $(foreach K2_ID,$(K2_IDS),$(BIN_DIR)/build_$(K2_ID))

RES_FILES = $(foreach K2_ID,$(K2_IDS),\
				$(foreach TC_ID,$(TC_IDS),\
					results/$(K2_ID).$(TC_ID)))

GEN_FILES = $(foreach K2_ID,$(K2_IDS),\
					$(BIN_DIR)/gen_k2_$(K2_ID))

K2T_RES_FILES = $(foreach K2_ID,$(K2_IDS),\
					$(foreach TC_ID,$(TC_IDS),\
						results-k2t/$(K2_ID).$(TC_ID)))

RESULT_FILE=results/all.txt

all: execs

execs: $(K2_EXECS)

timing: execs $(RES_FILES)
	@cat $(RES_FILES) > $(RESULT_FILE)
	@cd visualize;make

../tmp/K2T.%: $(DL) $(GEN_FILES)
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval K2_ID:=$(call dim,2,$*))
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval NUM_BYTE:=$(call config_select,test_case.config,$(TC_ID),5))
	@$(BIN_DIR)/gen_k2_$(K2_ID) $(TC_PATH) "../tmp/K2T.$(TC_ID).VECTOR" "../tmp/K2T.$(TC_ID).$(K2_ID)"

# Execute $(BIN_DIR)/build_[K2_ID] and write result
results/%: test_case.config $(DL) $(DL_K2T) execs
	$(eval K2_ID:=$(call dim,1,$*))
	$(eval TC_ID:=$(call dim,2,$*))
	$(eval K2_TEX_NAME:=$(call config_select,k2tree.config,$(K2_ID),3))
	$(eval TC_TEX_NAME:=$(call config_select,test_case.config,$(TC_ID),3))
	$(eval K2T:=$(strip $(call config_select,test_case.config,$(TC_ID),6)))
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval TC_TYPE:=$(call config_select,test_case.config,$(TC_ID),5))
	$(eval TC_SIZE:=$(shell wc -c <$(TC_PATH)))
	$(eval ARGS:="../tmp/K2T.$(TC_ID).$(K2_ID)")
	@echo "Running bin/build_$(K2_ID) on $(TC_ID)"
	@echo "# K2_ID = $(K2_ID)" > $@
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# K2_TEX_NAME = $(K2_TEX_NAME)">>$@
	@echo "# TC_TEX_NAME = $(TC_TEX_NAME)">>$@
	@echo "# TC_SIZE = $(TC_SIZE)">>$@
	@$(BIN_DIR)/build_$(K2_ID) $(ARGS) >> $@

# $(BIN_DIR)/build_[K2_ID]
$(BIN_DIR)/build_%: $(SRC_DIR)/k2_time_and_space.cpp k2tree.config
	$(eval K2_ID:=$(call dim,1,$*))
	$(eval K2_TYPE:=$(call config_select,k2tree.config,$(K2_ID),2))
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -DK2_TYPE="$(K2_TYPE)" -L$(LIB_DIR)\
		$(SRC_DIR)/k2_time_and_space.cpp -I$(INC_DIR) -o $@ $(LIBS)

$(BIN_DIR)/gen_k2_%: $(SRC_DIR)/gen_k2t.cpp
	$(eval K2_ID:=$(call dim,1,$*))
	$(eval K2_TYPE:=$(call config_select,k2tree.config,$(K2_ID),2))
	@$(MY_CXX) $(CFLAGS) $(C_OPTIONS) -DK2_TYPE="$(K2_TYPE)" -L$(LIB_DIR)\
		$(SRC_DIR)/gen_k2t.cpp -I$(INC_DIR) -o $@ $(LIBS) -ldivsufsort -ldivsufsort64

include ../Make.download

clean-build:
	@echo "Remove executables"
	rm -rf $(BIN_DIR)/build*
	rm -rf $(BIN_DIR)/gen*

clean-result:
	@echo "Remove results"
	rm -rf results/*

cleanall: clean-build clean-result

=== submodules/sdsl-lite/benchmark/suffix_trees/Makefile ===
include ../Make.helper
LIBS=-ldivsufsort -ldivsufsort64
SRC_DIR=src
TMP_DIR=../tmp

TC_IDS:=$(call config_ids,test_case.config)
TC_IDS_INT:=$(call config_ids,test_case_int.config)
TC_PATHS:=$(call config_column,test_case.config,2)
TC_PATHS_INT:=$(call config_column,test_case_int.config,2)
IDX_IDS:=$(call config_ids,index.config)
IDX_IDS_INT:=$(call config_ids,index_int.config)
COMPILE_IDS:=$(call config_ids,compile_options.config)
DEFAULT_COMPILE_ID:=$(word 1, $(COMPILE_IDS))

BUILD_EXECS           = $(foreach IDX_ID,$(IDX_IDS),bin/build_cst_$(IDX_ID))
BUILD_EXECS_INT       = $(foreach IDX_ID,$(IDX_IDS_INT),bin/build_int_cst_$(IDX_ID))
CST_EXECS            = $(foreach IDX_ID,$(IDX_IDS),\
						  $(foreach COMPILE_ID,$(COMPILE_IDS),bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID)))
CST_EXECS_INT        = $(foreach IDX_ID,$(IDX_IDS_INT),\
						  $(foreach COMPILE_ID,$(COMPILE_IDS),bin/time_and_space_int_cst_$(IDX_ID).$(COMPILE_ID)))
NODE_DEPTH_EXECS      = bin/depth_stats bin/depth_stats_int
INDEXES               = $(foreach TC_ID,$(TC_IDS),\
						  $(foreach IDX_ID,$(IDX_IDS),indexes/$(TC_ID).$(IDX_ID).byte))
INDEXES_INT           = $(foreach TC_ID,$(TC_IDS_INT),\
						  $(foreach IDX_ID,$(IDX_IDS_INT),indexes/$(TC_ID).$(IDX_ID).int))
INDEX_FILES           = $(foreach IDX,$(INDEXES),$(IDX))
INDEX_FILES_INT       = $(foreach IDX,$(INDEXES_INT),$(IDX))
RES_FILES             = $(foreach TC_ID,$(TC_IDS),\
						  $(foreach IDX_ID,$(IDX_IDS),\
							$(foreach COMPILE_ID,$(COMPILE_IDS),results/$(TC_ID).$(IDX_ID).$(COMPILE_ID).byte)))
RES_FILES_INT         = $(foreach TC_ID,$(TC_IDS_INT),\
						  $(foreach IDX_ID,$(IDX_IDS_INT),\
							$(foreach COMPILE_ID,$(COMPILE_IDS),results/$(TC_ID).$(IDX_ID).$(COMPILE_ID).int)))
NODE_STATS            = $(foreach TC_ID,$(TC_IDS),stats/$(TC_ID).byte.depth.txt)
NODE_STATS_INT        = $(foreach TC_ID,$(TC_IDS_INT),stats/$(TC_ID).int.depth.txt)

RES_FILE = results/all.txt

all: execs

timing: input\
		$(BUILD_EXECS) $(BUILD_EXECS_INT)\
		$(CST_EXECS) $(CST_EXECS_INT)\
		indexes\
		$(RES_FILES) $(RES_FILES_INT)
	cat $(RES_FILES) $(RES_FILES_INT) > $(RES_FILE)
	@cd visualize; make

depth: input $(NODE_DEPTH_EXECS) $(NODE_STATS) $(NODE_STATS_INT)

input: $(TC_PATHS) $(TC_PATHS_INT)

execs: $(BUILD_EXECS) $(BUILD_EXECS_INT) $(CST_EXECS) $(CST_EXECS_INT) $(NODE_DEPTH_EXECS)

indexes: $(INDEXES) $(INDEXES_INT)

# bin/build_cst_[IDX_ID]
bin/build_cst_%: $(SRC_DIR)/build_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index.config,$(IDX_ID),2))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/build_int_cst_[IDX_ID]
bin/build_int_cst_%: $(SRC_DIR)/build_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$(IDX_ID),2))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/time_and_space_cst_[INDEX_ID].[COMPILE_ID]
bin/time_and_space_cst_%: $(SRC_DIR)/time_and_space_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index.config,$(IDX_ID),2))
	$(eval IDX_REF_TYPE:=$(REF_CST_TYPE))
	$(eval COMPILE_ID:=$(call dim,2,$*))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# bin/time_and_space_int_cst_[INDEX_ID].[COMPILE_ID]
bin/time_and_space_int_cst_%: $(SRC_DIR)/time_and_space_cst.cpp
	$(eval IDX_ID:=$(call dim,1,$*))
	$(eval IDX_TYPE:=$(call config_select,index_int.config,$(IDX_ID),2))
	$(eval IDX_REF_TYPE:=$(REF_CST_TYPE_INT))
	$(eval COMPILE_ID:=$(call dim,2,$*))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

bin/depth_stats: $(SRC_DIR)/depth_stats.cpp
	$(eval IDX_TYPE:=$(REF_CST_TYPE))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

bin/depth_stats_int: $(SRC_DIR)/depth_stats.cpp
	$(eval IDX_TYPE:=$(REF_CST_TYPE_INT))
	$(eval COMPILE_ID:=$(DEFAULT_COMPILE_ID))
	$(eval COMPILE_OPTIONS:=$(call config_select,compile_options.config,$(COMPILE_ID),2))
	$(MY_CXX) $(MY_CXX_FLAGS) $(COMPILE_OPTIONS) -DCST_TYPE="$(IDX_TYPE)" -L$(LIB_DIR) -I$(INC_DIR) -o $@ $< $(LIBS)

# indexes/[TC_ID].[IDX_ID].byte
indexes/%.byte:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	$(eval TIME_FILE:=stats/$(TC_ID).$(IDX_ID).construction.html)
	$(eval STATS_FILE:=stats/$(TC_ID).$(IDX_ID).structure.html)
	@echo "Building index $(IDX_ID) on $(TC_ID) (byte alphabet)"
	@bin/build_cst_$(IDX_ID) $(TC_PATH) $(TMP_DIR) $@ $(TIME_FILE) $(STATS_FILE)

# indexes/[TC_ID].[IDX_ID].int
indexes/%.int:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval TC_PATH:=$(call config_select,test_case_int.config,$(TC_ID),2))
	$(eval TIME_FILE:=stats/$(TC_ID).$(IDX_ID).construction.html)
	$(eval STATS_FILE:=stats/$(TC_ID).$(IDX_ID).structure.html)
	@echo "Building index $(IDX_ID) on $(TC_ID) (int alphabet)"
	@bin/build_int_cst_$(IDX_ID) $(TC_PATH) $(TMP_DIR) $@ $(TIME_FILE) $(STATS_FILE)

# Format: results/[TC_ID].[INDEX_ID].[COMPILE_ID].byte
results/%.byte:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval COMPILE_ID:=$(call dim,3,$*))
	@echo "Running bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) on $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) indexes/$(TC_ID).$(IDX_ID).byte >> $@

# Format: results/[TC_ID].[INDEX_ID].[COMPILE_ID].int
results/%.int:
	$(eval TC_ID:=$(call dim,1,$*))
	$(eval IDX_ID:=$(call dim,2,$*))
	$(eval COMPILE_ID:=$(call dim,3,$*))
	@echo "Running bin/time_and_space_cst_$(IDX_ID).$(COMPILE_ID) on $(TC_ID)"
	@echo "# TC_ID = $(TC_ID)" >> $@
	@echo "# IDX_ID = $(IDX_ID)" >> $@
	@echo "# COMPILE_ID = $(COMPILE_ID)" >> $@
	@bin/time_and_space_int_cst_$(IDX_ID).$(COMPILE_ID) indexes/$(TC_ID).$(IDX_ID).int >> $@

# stats/[TC_ID].byte.depth.txt
stats/%.byte.depth.txt:
	$(eval TC_ID:=$*)
	$(eval TC_PATH:=$(call config_select,test_case.config,$(TC_ID),2))
	@echo "Generating node depth statistics for $(TC_ID) (byte alphabet)"
	@bin/depth_stats $(TC_PATH) $(TMP_DIR) >> $@

# stats/[TC_ID].int.depth.txt
stats/%.int.depth.txt:
	$(eval TC_ID:=$*)
	$(eval TC_PATH:=$(call config_select,test_case_int.config,$(TC_ID),2))
	@echo "Generating node depth statistics for $(TC_ID) (int alphabet)"
	@bin/depth_stats_int $(TC_PATH) $(TMP_DIR) >> $@

../data/%:
	$(eval URL:=$(call config_filter,test_case.config,$@,4))
	@$(if $(URL),,\
		$(eval URL:=$(call config_filter,test_case_int.config,$@,4))\
		@$(if $(URL),,\
			$(error "No download link nor generation program specified for test case $@") ) )
	@echo "Download input from $(URL) using curl"
	$(eval DEST_DIR:=$(shell dirname $@))
	cd $(DEST_DIR); curl -O $(URL)
	$(eval FILE:=$(DEST_DIR)/$(notdir $(URL)))
	@$(if $(filter-out ".gz",$(FILE)),\
		echo "Extract file $(FILE) using gunzip";\
		gunzip $(FILE))

clean:
	rm -f $(BUILD_EXECS) $(BUILD_EXECS_INT) $(FCST_EXECS) $(FCST_EXECS_INT) $(FCST_VERIFY_EXECS) $(FCST_VERIFY_EXECS_INT) $(TMP_DIR)/*

clean_indexes:
	rm -f $(INDEX_FILES) $(INDEX_FILES_INT)

clean_results:
	rm -f $(RES_FILES) $(RES_FILES_INT)

cleanall: clean clean_indexes clean_results

=== test/performance/core/simd/CMakeLists.txt ===
seqan3_benchmark(simd_algorithm_benchmark.cpp)
seqan3_benchmark(view_to_simd_chunk_benchmark.cpp)

=== test/unit/alphabet/structure/CMakeLists.txt ===
seqan3_test(dot_bracket3_test.cpp)
seqan3_test(dssp9_test.cpp)
seqan3_test(structured_aa_test.cpp)
seqan3_test(structured_rna_test.cpp)
seqan3_test(wuss_test.cpp)

=== test/unit/std/concept/CMakeLists.txt ===
seqan3_test(core_language_test.cpp)
seqan3_test(comparison_test.cpp)
seqan3_test(object_test.cpp)
seqan3_test(callable_test.cpp)
seqan3_test(iterator_test.cpp)
seqan3_test(range_test.cpp)

=== test/unit/alignment/matrix/detail/CMakeLists.txt ===
seqan3_test (aligned_sequence_builder_test.cpp)
seqan3_test (alignment_matrix_column_major_range_test.cpp)
seqan3_test (alignment_score_matrix_one_column_banded_test.cpp)
seqan3_test (alignment_score_matrix_one_column_test.cpp)
seqan3_test (alignment_trace_matrix_full_banded_test.cpp)
seqan3_test (alignment_trace_matrix_full_test.cpp)
seqan3_test (trace_iterator_banded_test.cpp)
seqan3_test (trace_iterator_test.cpp)
seqan3_test (two_dimensional_matrix_test.cpp)
